#!/usr/bin/python -t

from slithy.library import *
from slithy.presentation import *
from slithy.util import *
from slithy.objects import Element, parameter_check
import re, string
from slithy.objects import Element
from slithy import anim,transition
from resources import font, font_style, colors, Default_background
from Numeric import arctan, sin, cos, pi



#import Image
#import EpsImagePlugin
#import JpegImagePlugin

#transition_default = Transition()

#def auto_string(string):
#    string = re.compile( '\b"([A-Za-z]+)').sub('\210$1', string )
#    string = re.compile( '([a-z]+)"\b').sub( '$1\211', string )
#    string = re.compile( '<=').sub( '\178', string )
#    return string
#
#print auto_string(" 1 <= 2 ")
exit

# Default_background = Fill( style = 'horz', color = black, color2 = Color(0,0,0.3) )
# I know there's a better way.
Default_textsize=22
Default_titlesize=28
Default_citesize=18
Default_fadetime=0.1
Show_slide_number=True
# Show_slide_number=False
Slide_number = 0

class MyBulletedList(BulletedList):
    def __init__( self, _viewport, **_params ):
        initparams = ( ('font', 'object', None),
                       ('color', 'color', black),
                       ('bullet', 'object', [None,  [font['wingding'],'w'], '-', '-', '-', '-', '-'] ),
                       ('bulletsep', 'scalar', 0.5),
                       ('size', 'scalar', 1.0),
                       ('sizescale', 'scalar', 0.8),
                       ('indent', 'scalar', 1.0),
                       ('leading', 'scalar', 0.5),
                       ('_alpha', 'scalar', 1.0),
                       ('show', 'scalar', 0.0),
                       )

        bad = parameter_check( initparams, _params )
        if bad:
            raise ValueError, "no parameter '%s' for BulletedList()" % (bad,)

#        superparams = _params   # copy our params for super.
#        del superparams[bullet] # don't give super a list for a bullet.
#        BulletedList.__init__(self, _viewport, _params) # call super.
        
        self._startitemlist = []
        moreparams = ( ('items', 'object', self._startitemlist),
                       )

        self.counter = [ 0, 0, 0, 0, 0 ]
        self._params = initparams + moreparams
        self._defaults = _params
        self._viewport = _viewport

        
    def clear( self ):
        # doesn't work.  dammit.  working around this, but I wish it would just work.
        if anim.defining_animation():
            anim.set( self.items, [])
        else:
            self._startitemlist = []

    def add_item( self, level, text, bullet='', duration = 0.0, trans = transition.default ):
        if anim.defining_animation():
            before = anim.get( self.items )
            after = before + [(level,text,bullet)]
            anim.set( self.items, after )
            if duration:
                trans( duration, self.show, len(after) )
            else:
                anim.set( self.show, len(after) )
        else:
            self._startitemlist.append( (level, text, bullet) )

    def add_bigarray(self, text):
        bullets = [None,  [font['wingding'],'w'], '-', '-', '-', '-', '-']
        stripper = re.compile( '^[\*\+]* *' )
        indent = 0
        indentp = 0
        if(type(text[0]) is str):
            for c in text[0]:
                if c == '*':
                    indent = indent + 1
                elif c == '+':
                    indentp = indentp + 1
                else:
                    break 
            text[0] = stripper.sub( '', text[0] )
        if(indentp > 0.0):
            self.counter[indentp] += 1
            bull = "%d." % self.counter[indentp]
            self.counter[indentp+1] = 0
            self.counter[indentp+2] = 0
            self.counter[indentp+3] = 0
        else:
            bull = bullets[indent]

        self.add_item(max(indent,indentp), text, bull)

    def add_bigstring(self, text):
        self.add_bigarray([ text ])
        #stripper = re.compile( '^[\*\+]* *' )
        #bullets = [None,  [font['wingding'],'w'], '-', '-', '-', '-', '-']
        #for ln in string.split(text, '\n'):
            #indent = 0
            #indentp = 0
            #for c in ln:
                #if c == '*' or c == '+':
                    #indent = indent + 1
                #elif c == '+':
                    #indentp = indentp + 1
                #else:
                    #break 
            #text_line = stripper.sub( '', ln )
            #if len(text_line) > 0:
                #self.add_item(indent, stripper.sub( '', ln ), bullets[indent])


# inherits remove_item
            
# overrides render
    def render( self, d, view, t ):
        push()
        try:
            items = d['items']
            
            ox, oy, ulen, utheta, aspect = view
            if utheta == 0.0:
                x = ox
                y = oy + ulen / aspect
            else:
                translate( ox, oy )
                rotate( utheta )
                x = 0
                y = ulen / aspect
                
            basesize = d['size']
            sizescale = d['sizescale']
            indent = d['indent'] * basesize
            leading = d['leading'] + 1
            font = d['font']
            bulletsep = d['bulletsep']
            alpha = d['_alpha']
            show = d['show']
            
            scales = [(basesize, 0.0)]
            
            color( d['color'] )

            ypos = None
            k = 0
            for l, t, bull in items:
                if show < k:
                    break
                if int(show) == k:
                    showalpha = show - k
                else:
                    showalpha = 1
                k += 1
                
                # create the scales array.
                while len(scales) <= l:
                    s, i = scales[-1]
                    scales.append( (s * sizescale, i + indent) )

                s, i = scales[l]
                if ypos is None:
                    ypos = y - s
                else:
                    ypos -= leading * s

                if bull:
                    p = text( x + i, ypos, bull, font,
                              size = s, anchor = 'fw',
                              _alpha = alpha * showalpha )
                    i += p['width'] + bulletsep * s

                p = text( x + i, ypos, t, font, size = s, anchor = 'fw', wrap = ulen - i, _alpha = alpha * showalpha )
                ypos -= (p['lines']-1) * s 
                
        finally:
            pop()
        
    def __str__( self ):
        return '<bulletedlist element>'
    
        
        

def title_slide(title="title", subtitle="", author="author", date="date",
                titlesize=26, subtitlesize=22, authorsize=19, datesize=18):
    global Slide_number
    tjust = 0
    if subtitle == "" :
        tjust = 0.5
    else:
        tjust = 0.4
    print title
    print subtitle
    print author
    print date
    print 
        
    title = Text(get_camera().top(tjust), text=title, font=font['myriad'], size=titlesize, justify=0.5, vjustify=0.5, color=colors['title'])
    subtitle = Text(get_camera().bottom(0.65), text=subtitle, font=font['myriad'], size=subtitlesize, justify=0.5, color=colors['title'])
    author = Text(get_camera().bottom(0.5), text=author, font=font['myriad'], size=authorsize, justify=0.5, color=colors['foreground'])
    date = Text(get_camera().bottom(0.22), text=date, font=font['myriad'], size=datesize, justify=0.5, color=colors['foreground'])
    start_animation(Default_background,title,subtitle,author,date)
    Slide_number+=1
    return end_animation()

def make_title(title="title", alpha=1, titlesize=Default_titlesize):
    global Slide_number
    r = get_camera().top(0.18).bottom(0.9).inset(0.05)
    print Slide_number, title
    Slide_number+=1
    return Text(r, text=title, font=font['myriad'], size=titlesize, justify=0.0, color=colors['title'], _alpha=alpha)

def make_cite(title="title", alpha=1, citesize=Default_citesize):
    r = get_camera().top(0.18).bottom(0.9).inset(0.05)
    return Text(r, text=title, font=font['myriad'], size=citesize, justify=1.0, vjustify=0.3, color=colors['title'], _alpha=alpha)


def b_slide():
    title = make_title("Reverse-Engineering?")
    bl = BulletedList( get_camera().bottom(0.8).inset(0.05), font=font['myriad'], size=18, show=4, color=colors['foreground'])
    bl.add_item(0, "hello")
    bl.add_item(1, "que tal")
    start_animation(Default_background,title,bl)
    bl.add_item(0, "hello")
    return end_animation()

def im_slide():
    title = make_title("Hops?")
    #epsimage = load_image('hops-pp.eps')
    imagepath.append ('.')
    epsimage = search_image('cheswick.jpg')
    print epsimage
    slimage = image(0, 0, epsimage, anchor = 'sw', width=4, height=1)
    print slimage
    im = Drawable( get_camera().bottom(0.8).inset(0.05), slimage)
    #print im
    return im
#    start_animation(bg,title,im)
#    return end_animation()


def basic_slide(title, text):
    title = make_title(title)
    bl = MyBulletedList( get_camera().bottom(0.85).inset(0.05), font=font['myriad'], size=18, show=40, color=colors['foreground'])
    bl.add_bigstring(text)
    start_animation(Default_background,title,bl)
    return end_animation()


def fade_transition_elts_in(elts, fade="both", fadetime=Default_fadetime):
    if fade is "in" or fade is "both":
        parallel()
        for elt in elts:
            fade_in(fadetime,elt)
        end()
    else:
        for elt in elts:
            fade_in(0,elt)

def fade_transition_elts_out(elts,fade="both",fadetime=Default_fadetime):
    if fade is "out" or fade is "both":
        parallel()
        for elt in elts:
            fade_out(fadetime,elt)
        end()

def callout_object( caption = (STRING,"set text"),
                    radius = (SCALAR,0, 300, 20),
                    branch = (SCALAR,-1, 300, -1),
                    direction = (SCALAR, 0, 359, 45),
                    incolor = (COLOR, white),
                    x = (SCALAR, 0, 400, 200),
                    y = (SCALAR, 0, 300, 150),
                    font_size = (SCALAR,1,30,20),
                    alpha = (SCALAR, 0, 1, 1)):
    set_camera(Rect(0,0,400,300))
    linethickness = radius/6.0+1.5

    if(branch < 0):
        branch = radius

    # TODO: use doug's __abs__ function that gets intensity with the right formula
    if incolor[0] + incolor[1] + incolor[2] > 1.5:
        fadeback = black
    else:
        fadeback = white

    color(incolor, alpha)
    thickness(linethickness)
    p=Path()
    p.moveto(x + radius * sin(direction * pi / 180.0), 
             y + radius * cos(direction * pi / 180.0))
    x1 = x + ( radius + branch ) * sin(direction * pi / 180.0)
    y1 = y + ( radius + branch ) * cos(direction * pi / 180.0)
    p.lineto(x1, y1)
    border = font_size/5.0 + 1.0
    # 'l' in the anchor specifies the baseline of the last line,
    # used instead of 's' to avoid problems where "g" or "y" raise the box.
    if(direction>180):
        extents = text( x1 - border, y1+radius/3.0, caption, font_style['base'],
                        size = font_size, anchor = 'le',
                        _alpha = 0)
        push()
        color(fadeback,  min([ 0.7, alpha ]))
        rectangle(extents['left'] - border, extents['bottom'] - border,
                  extents['right'] + border, extents['top']+ border)
        pop()
        extents = text( x1 - border, y1+radius/3.0, caption, font_style['base'],
                        size = font_size, anchor = 'le',
                        _alpha = alpha)
        
        p.lineto(extents['left'], y1)
    else:
        extents = text( x1 + border, y1+radius/3.0, caption, font_style['base'],
                        size = font_size, anchor = 'lw',
                        _alpha = 0)
        push()
        color(fadeback,  min([ 0.7, alpha ]))
        rectangle(extents['left'] - border, extents['bottom'] - border,
                  extents['right'] + border, extents['top']+ border)
        pop()
        extents = text( x1 + border, y1+radius/3.0, caption, font_style['base'],
                        size = font_size, anchor = 'lw',
                        _alpha = alpha)
        p.lineto(extents['right'], y1)
    widestroke(p, linethickness)
    # draw the circle last, in case it overlaps the shaded box at angles near 180
    circle(radius, x, y)


def fade_transition_elts(elts, fade="both", fadetime=Default_fadetime,callouts=[]):
    fade_transition_elts_in(elts,fade,fadetime)
    anim.pause()
    if len(callouts) > 0:
        for c in callouts:
            print "doing %s\n" % c[0]
            d = Drawable( get_camera(), callout_object, _alpha=0 )
            enter(d)
            set(d.caption, c[0])
            set(d.radius, c[1])
            set(d.direction, c[2])
            set(d.incolor, c[3])
            set(d.x, c[4])
            set(d.y, c[5])
            set(d.alpha, 1)
            fade_in(fadetime,d);
            anim.pause()
            fade_out(fadetime,d);
            exit(d)
            
    fade_transition_elts_out(elts,fade,fadetime)

def add_bullets_to_list(bl, bullets):
    for text in bullets:
        if type(text) is str:
            print " " +text
            bl.add_bigstring(text)
        else:
            print " ",
            for m in text:
                if type(m) is str:
                    print m,
            bl.add_bigarray(text)
            print 

# can be called both within and as an animation....
# though I'm just starting to figure this out...
def bullet_slide(title="title", titlesize=Default_titlesize, bullets=[],
                 bulletsize=Default_textsize, bulletsfrac=0.85,
                 fade="both", fadetime=Default_fadetime, cite=None):
    global Slide_number
    title = make_title(title, alpha=0, titlesize=titlesize)
    if(cite):
        cite = make_cite(cite)

    bl = MyBulletedList( get_camera().bottom(bulletsfrac).inset(0.05), font=font['myriad'], size=bulletsize, show=40, color=colors['foreground'], _alpha=0)
    if( Show_slide_number ):
        slnum_text = "%d" % Slide_number
    else:
        slnum_text = ""
    num = Text(get_camera().bottom(0.07).right(0.07),
               text=slnum_text,
               font=font['myriad'], size=10,
               justify=0.5, color=colors['foreground'])

    elements = [ title, bl, num ]
    if(cite):
        elements.append(cite)

    if(defining_animation()):
        enter(*elements)
        add_bullets_to_list(bl, bullets)
        fade_transition_elts(elements, fade=fade)
        exit(*elements)
    if(not defining_animation()):
        start_animation(Default_background,*elements)
        add_bullets_to_list(bl, bullets)
        fade_transition_elts(elements, fade=fade)
        return end_animation()

def graph_slide(title="title", picture="", fade="both",
                titlesize=Default_titlesize,
                fadetime=Default_fadetime,
                drawable=None,
                caption="", captionsize=20,
                callouts=[]):
    title = make_title(title, titlesize=titlesize)
    if(not caption == ""):
        imagerect = get_camera().bottom(0.85).top(0.8)
    else:
        imagerect = get_camera().bottom(0.85)

    if type(picture) is str:
        image = search_image(picture)
    else:
        image = picture

    if(fade is "both" or fade is "in"):
        initalpha = 0.0
    else:
        initalpha = 1.0

    if drawable is None:
        im = Image( imagerect, image=image, _alpha=initalpha)
    else:
        im = Drawable( imagerect, drawable, _alpha=initalpha)

    if(not caption == ""):
        cap = Text(get_camera().bottom(0.85).bottom(0.25),
                   text=caption,font=font['myriad'], size=captionsize, justify=0.5, vjustify=0.7, color=colors['title'], _alpha=initalpha)
        elts = [title,im,cap]
    else:
        # cap = Text(get_camera().bottom(0.85).bottom(0.1),
                         # text="",font=font['myriad'], size=captionsize, justify=0.5, vjustify=0.5, color=colors['title'], _alpha=initalpha)
        elts = [title,im]
        
    if(defining_animation()):
        enter(*elts)
        fade_transition_elts(elts, fade=fade,callouts=callouts)
        exit(*elts)
    if(not defining_animation()):
        start_animation(Default_background, *elts)
        fade_transition_elts(elts, fade=fade,callouts=callouts)
        return end_animation()


def graph_slide_left(title="title", picture="", fade="both", fadetime=Default_fadetime,
                     bullets="", bulletsize=Default_textsize, captionsize=20, leftpaneslice=0.3):
    title = make_title(title)
    if(fade is "both" or fade is "in"):
        initalpha = 0.0
    else:
        initalpha = 1.0
    im = Image( get_camera().bottom(0.85).left(leftpaneslice).inset(0.05),
                image=picture, _alpha=initalpha)
    bl = MyBulletedList( get_camera().bottom(0.85).right(1.0-leftpaneslice).inset(0.05),
                         font=font['myriad'], size=bulletsize, show=40,
                         color=colors['foreground'], _alpha=initalpha)
        
    if(defining_animation()):
        enter(title,im,bl)
        add_bullets_to_list(bl, bullets)
        fade_transition_elts([title, im, bl], fade=fade)
        exit(title,im,bl)
    if(not defining_animation()):
        start_animation(Default_background, im, bl, title)
        add_bullets_to_list(bl, bullets)
        fade_transition_elts([title, im, bl], fade=fade)
        return end_animation()


def graph_slide_bottom(title="title", picture="", fade="both", fadetime=Default_fadetime,
                       drawable=None,
                       bullets="", titlesize=Default_titlesize, bulletsize=Default_textsize, bottompaneslice=0.3):
    title = make_title(title, alpha=1, titlesize=titlesize)
    if(fade is "both" or fade is "in"):
        initalpha = 0.0
    else:
        initalpha = 1.0
    if drawable is None:
        im = Image( get_camera().bottom(bottompaneslice).inset(0.05),
                    image=picture, _alpha=initalpha)
    else:
        im = Drawable( get_camera().bottom(bottompaneslice).inset(0.05),
                       drawable, _alpha=initalpha)

    # math is not quite right.
    bl = MyBulletedList( get_camera().bottom(0.85).top(1.0-bottompaneslice).inset(0.05),
                         font=font['myriad'], size=bulletsize, show=40,
                         color=colors['foreground'], _alpha=initalpha)
        
    if(defining_animation()):
        enter(title,im,bl)
        add_bullets_to_list(bl, bullets)
        fade_transition_elts([title, im, bl], fade=fade)
        exit(title,im,bl)
    if(not defining_animation()):
        start_animation(Default_background, im, bl, title)
        add_bullets_to_list(bl, bullets)
        fade_transition_elts([title, im, bl], fade=fade)
        return end_animation()

test_objects( callout_object, clear_color=colors['background'] )
