from slithy.library import *
from slithy import *
from slithy.util import *
import re, string, copy
from slithy import anim,transition
from resources import font, font_style, colors, Default_background
from myslithy import *

def overload(completion=(SCALAR,0,1,0)):
    camera_width = 300
    center_x = camera_width / 2 
    border= 8
    set_camera(Rect(0,0-border,camera_width,150))
    color(white)
    font_size=30
    interval = font_size+5
    y0 = 0 
    y1 = interval +  max(0,(0.2-completion) * 1000)
    y2 = 2* interval +  max(0,(0.4-completion) * 1000)
    y3 = 3*interval +  max(0,(0.6-completion) * 1000)
    lrborder= border * 2

    addrs = text(center_x,0, "IP Addresses", font=font_style['base'], size=font_size* (1.1), anchor='s', _alpha=1)
    frame(addrs['left'] - lrborder, addrs['bottom'] - border,
          addrs['right'] + lrborder, addrs['top'] + border)

    reach = text(center_x,y1, [ colors['lgreen'], "Reachability" ], font=font_style['base'], size=font_size, anchor='s')
    auth = text(center_x,y2 + (font_size/6), [ colors['lred'], "Authorization"] , font=font_style['base'], size=font_size, anchor='s')
    account = text(center_x,y3, [colors['title'], "Accountability" ], font=font_style['base'], size=font_size, anchor='s')

def overload_sequence(title="Addresses are Overloaded",
                      reachability_text=[ "Reachability: Hierarchical addressing facilitates routing.", colors['lgreen'], " (good)" ] ,
                      authorization_text=[ "Authorization: On-line journals and .rhosts assume that if you come from a good address, you must be a good client.", colors['lred'], " (bad)" ],
                      accountability_text= [ "Accountability: Many assume that if they log an IP address, they can find or blacklist any miscreant.", colors['title'], " (not so good)" ] ):
    title = make_title(title)
    r=get_camera().bottom(0.85).top(0.5)
    c1 = Drawable(r, overload, alpha=1, completion=0, _alpha=1)
    start_animation(Default_background,title,c1)
    enter(c1)
    fade_in(0.5, c1)
    cap = Text(get_camera().bottom(0.85).bottom(0.4).inset(0.08),
               text=reachability_text,font=font['myriad'], size=18, justify=0,
               vjustify=0, color=colors['foreground'], _alpha=0)
    enter(cap)
    anim.pause()

    set(cap.text, reachability_text)
    parallel()
    fade_in(0.5, cap)
    smooth(1, c1.completion, 0.2) # becomes 0.2
    end()
    anim.pause()
    fade_out(0.2, cap)
    set(cap.text, authorization_text)
    parallel()
    fade_in(0.5, cap)
    smooth(1, c1.completion, 0.4) # becomes 0.22
    end()
    anim.pause()
    fade_out(0.2, cap)
    set(cap.text, accountability_text)
    parallel()
    fade_in(0.5, cap)
    smooth(1, c1.completion, 0.6) # becomes 0.22
    end()
    anim.pause()
    return end_animation()

